Opened 15 months ago

Closed 5 months ago

#10440 closed defect (fixed)

SCI: PHARKAS Mac no longer running at all, ScummVM complaining about missing or corrupt game resources

Reported by: eisnerguy1 Owned by: bluegr
Priority: high Component: Engine: SCI
Keywords: Cc:
Game: Freddy Pharkas: Frontier Pharmacist

Description

Freddy Pharkas: Frontier Pharmacist (Macintosh/English)
Tried in ScummVM 2.1.0git956-gc759dc7 (Feb 26 2018 04:51:08)
Mac OS X 10.12.6

So, I'm trying to run the Mac version of Freddy Pharkas. While there were small issues in earlier releases, the game ran somewhat at least. Now, I'm only seeing an error message complaining about missing or corrupt game resources. I've attached a screenshot of this error. Terminal also spits out tons of errors about almost every aspect of the game's files. The files come from a fresh installation from disk images I made from the floppies themselves 2 years ago.

Attachments (2)

pharkas_mac_scummvm.png (77.4 KB) - added by eisnerguy1 15 months ago.
Error Screenshot
pharkas_mac_terminal_error_master.txt (97.6 KB) - added by eisnerguy1 15 months ago.
Terminal output

Download all attachments as: .zip

Change History (10)

Changed 15 months ago by eisnerguy1

Attachment: pharkas_mac_scummvm.png added

Error Screenshot

Changed 15 months ago by eisnerguy1

Terminal output

comment:1 Changed 15 months ago by eisnerguy1

Priority: normalhigh

comment:2 Changed 15 months ago by dafioram

What is the most recent version of scummvm that you were able to successfully run your game data with?

comment:3 in reply to:  2 Changed 15 months ago by eisnerguy1

Replying to dafioram:

What is the most recent version of scummvm that you were able to successfully run your game data with?

From what I could tell by some my other bug reports, the last version that could at least run the game data was this:
ScummVM 1.10.0git2888-ga925264 (Mar 27 2017 04:50:05)

I honestly don't remember if I tested any build newer than that save for the 2.0 release.

This version still had the other bugs I mentioned in my previous bug reports though.

Last edited 15 months ago by eisnerguy1 (previous) (diff)

comment:4 Changed 14 months ago by eisnerguy1

Still having the same issue as before with this build:

ScummVM 2.1.0git1198-g0a5dcfb (Mar 21 2018 04:51:57)
Mac OS X 10.12.6

comment:5 Changed 14 months ago by csnover

Thanks for your report! This is happening because MacResourceForkResourceSource gives out volume files which are for the data fork, which is the wrong fork, so every resource fails validation because the wrong size (the data fork’s size) is used to check offsets for files which exist in the resource fork. It turns out the one Mac game I have does not use resource forks, but rather standard RESOURCE files with data in the data fork, so I never noticed this during testing.

comment:6 in reply to:  5 Changed 14 months ago by eisnerguy1

Replying to csnover:

Thanks for your report! This is happening because MacResourceForkResourceSource gives out volume files which are for the data fork, which is the wrong fork, so every resource fails validation because the wrong size (the data fork’s size) is used to check offsets for files which exist in the resource fork. It turns out the one Mac game I have does not use resource forks, but rather standard RESOURCE files with data in the data fork, so I never noticed this during testing.

No problem. Glad to help in any way I can. How difficult is to fix something like this? No rush at all, just wondering.

comment:7 Changed 5 months ago by Filippos Karapetis <bluegr@…>

In 57f114cb:

SCI: Don't try to validate resources added from a Mac resource fork

The fix has been authored originally by csnover, adapted from commit ca420e44167e5ee488b4ad547104fa6b976e6f1c

Fixes Trac#10440, Trac#10892.

comment:8 Changed 5 months ago by bluegr

Owner: set to bluegr
Resolution: fixed
Status: newclosed

There are other changes before this commit. I've adapted it for the current codebase, and pushed it in commit 57f114cbc3f8ecea0668c732550afc638e3ee302.

Closing this, as well as the other linked bug.

Note: See TracTickets for help on using tickets.